package com.company.classicaudio.entity;

import io.jmix.core.FileRef;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.annotation.PostConstruct;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "INSTRUMENT")
@Entity
public class Instrument {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "NAME", nullable = false)
    @NotNull
    private String name;

    @Column(name = "AUDIO_FILE", length = 1024)
    private FileRef audioFile;

    @Column(name = "AUDIO_FILE_SIZE")
    private Long audioFileSize;

    @Column(name = "STORAGE_REMAINING")
    private Long storageRemaining = 0L;

    public Long getStorageRemaining() {
        return storageRemaining;
    }

    public void setStorageRemaining(Long storageRemaining) {
        this.storageRemaining = storageRemaining;
    }

    public Long getAudioFileSize() {
        return audioFileSize;
    }

    public void setAudioFileSize(Long audioFileSize) {
        this.audioFileSize = audioFileSize;
    }

    public FileRef getAudioFile() {
        return audioFile;
    }

    public void setAudioFile(FileRef audioFile) {
        this.audioFile = audioFile;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }


    @PostConstruct
    public void postConstruct() {
        setStorageRemaining(10000000L); // Just for demo purposes
    }
}